Viewing Issue Simple Details Jump to Notes ] Wiki ] View Advanced ] Issue History ] Print ]
ID Category Severity Reproducibility Date Submitted Last Update
0007415 [DCSS] Bug Report minor have not tried 2013-07-31 04:56 2015-11-26 14:58
Reporter magicpoints View Status public  
Assigned To wheals
Priority normal Resolution done  
Status resolved   Product Branch 0.13 ancient branch
Summary 0007415: Mephitic Cloud's autotargetter does not work properly
Description When you cast Meph, it will not autotarget at creatures outside of its range by 1 space, the way Fireball autotargets. The spell can be selected with z instead of Z, but it will center on the player instead. This happens for both poison-vulnerable enemies and poison-resistant enemies. (Additionally, Mephitic Cloud probably should not autotarget enemies with poison resistance.)
Additional Information
Tags No tags attached.
Attached Files png file icon DCSS-Meph_Targetting.png [^] (26,901 bytes) 2013-07-31 04:56

- Relationships
has duplicate 0008994resolvedwheals Area-effect spells (fireball, fire storm) should autotarget using the full area of effect 
related to 0010103new Fire storm default targeting is broken 

-  Notes
(0023620)
neil (administrator)
2013-08-01 23:42
edited on: 2013-08-01 23:47

This happens because Mephitic Cloud isn't guaranteed to splash into every adjacent cell unless it is at max power. In fact, once you max out the power, it starts targetting "correctly".

This happens because the edge-of-LOS explosion targetting code (directn.cc: _find_monster_expl() ) only considers cells that the explosion is guaranteed to hit. This check is necessary to avoid doing things like targetting IMB near the edge of LOS (where it probably won't explode anyway), or placing a firestorm with the monster only in the outer "maybe" radius. Changing the behaviour for meph should be done in a way that doesn't cause problems for these other spells.

One possibility would be to add a new affectedness type AFF_PROBABLY, and have targetters use that rather than AFF_MAYBE if thee probability of affecting the cell is sufficiently high.

For reference, for each of the eight surrounding cells, meph at power 0 has a 56% chance to place a cloud there, at power 25 a 67% chance, at power 50 a 78% chance, and at power 100 a 100% chance.

By comparison, firestorm at power 75 has a 0% chance of the larger radius, at power 100 a 24% chance, at power 150 a 49% chance, and a power 200 a 62% chance.

(0029825)
wheals (administrator)
2015-11-24 16:49

Possibly fixed by doy in https://github.com/crawl/crawl/commit/62b5303cbeee92; [^] we could keep an eye out to see if anything goes wrong because of it.
(0029844)
doy (developer)
2015-11-26 08:41

I went ahead and fixed this in 62b5303. While it's true that targeting the edge of LOS where it's unlikely to hit isn't great, it's not like leaving the targeter on the player is particularly better, and this situation only occurs when there is no better place to target anyway. I don't think trying to determine what "sufficiently high probability" means is going to result in anything that's particularly better at being understandable or predictable.
(0029848)
wheals (administrator)
2015-11-26 14:24

Looks like 0010103 has a case where the autotargeter targets 3 spaces away from a target with firestorm, but the player could put one two spaces away; possibly this behaviour could be more of a last resort than it is now.
(0029851)
doy (developer)
2015-11-26 14:58

Ah, yeah, good call. It should probably try first to target at max range, and then fall back to min range as a separate step. I'll see about fixing that this weekend.

- Issue History
Date Modified Username Field Change
2013-07-31 04:56 magicpoints New Issue
2013-07-31 04:56 magicpoints File Added: DCSS-Meph_Targetting.png
2013-08-01 23:42 neil Note Added: 0023620
2013-08-01 23:47 neil Note Edited: 0023620
2015-11-24 16:48 wheals Relationship added has duplicate 0008994
2015-11-24 16:49 wheals Note Added: 0029825
2015-11-24 16:49 wheals Status new => resolved
2015-11-24 16:49 wheals Fixed in Branch => 0.18 development branch
2015-11-24 16:49 wheals Resolution open => done
2015-11-24 16:49 wheals Assigned To => wheals
2015-11-26 08:41 doy Note Added: 0029844
2015-11-26 14:24 wheals Note Added: 0029848
2015-11-26 14:24 wheals Relationship added related to 0010103
2015-11-26 14:58 doy Note Added: 0029851


Mantis 1.1.8[^]
Copyright © 2000 - 2009 Mantis Group
Powered by Mantis Bugtracker